/**
 * Copyright (c) 2002-2004 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *   IBM - Initial API and implementation
 */
package org.eclipse.emf.java;


import org.eclipse.emf.ecore.EObject;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>JModel Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.emf.java.JModelElement#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.emf.java.JModelElement#getJNode <em>JNode</em>}</li>
 * </ul>
 *
 * @see org.eclipse.emf.java.JavaPackage#getJModelElement()
 * @model abstract="true"
 * @generated
 */
public interface JModelElement extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see org.eclipse.emf.java.JavaPackage#getJModelElement_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link org.eclipse.emf.java.JModelElement#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>JNode</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the value of the '<em>JNode</em>' attribute.
   * @see #setJNode(Object)
   * @see org.eclipse.emf.java.JavaPackage#getJModelElement_JNode()
   * @model dataType="org.eclipse.emf.java.JNode" transient="true"
   * @generated
   */
  Object getJNode();

  /**
   * Sets the value of the '{@link org.eclipse.emf.java.JModelElement#getJNode <em>JNode</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>JNode</em>' attribute.
   * @see #getJNode()
   * @generated
   */
  void setJNode(Object value);

  String getQualifiedName();

} // JModelElement
